package cn.com.qmth.scancentral.dao;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import cn.com.qmth.scancentral.bean.AbsentQueryDomain;
import cn.com.qmth.scancentral.bean.AnswerQueryDomain;
import cn.com.qmth.scancentral.bean.AssignedQueryDomain;
import cn.com.qmth.scancentral.entity.StudentEntity;
import cn.com.qmth.scancentral.vo.AbsentInfoVo;
import cn.com.qmth.scancentral.vo.AbsentQueryVo;
import cn.com.qmth.scancentral.vo.AnswerExportVo;
import cn.com.qmth.scancentral.vo.CampusVo;
import cn.com.qmth.scancentral.vo.ExamSiteVo;
import cn.com.qmth.scancentral.vo.ExportCetMarkingQueryVo;
import cn.com.qmth.scancentral.vo.ExportCetVo;
import cn.com.qmth.scancentral.vo.ImportStudentQueryVo;
import cn.com.qmth.scancentral.vo.ImportStudentVo;
import cn.com.qmth.scancentral.vo.ScanAnswerInfoVo;
import cn.com.qmth.scancentral.vo.StudentUploadVo;
import cn.com.qmth.scancentral.vo.answerquery.AnswerQueryVo;
import cn.com.qmth.scancentral.vo.assginedcheck.AssignedCheckExport;
import cn.com.qmth.scancentral.vo.examroom.ExamRoomScannedQuery;
import cn.com.qmth.scancentral.vo.examroom.ExamRoomScannedVo;
import cn.com.qmth.scancentral.vo.student.StudentExamRoomVo;
import cn.com.qmth.scancentral.vo.student.StudentPageQuery;
import cn.com.qmth.scancentral.vo.student.StudentPageVo;
import cn.com.qmth.scancentral.vo.student.StudentVo;
import cn.com.qmth.scancentral.vo.subject.SubjectScanProgressVo;

public interface StudentDao extends BaseMapper<StudentEntity> {

    List<CampusVo> listCampusByExamId(@Param("examId") Long examId);

    List<ExamSiteVo> listSiteByExamId(@Param("examId") Long examId);

    AbsentInfoVo absentInfo(@Param("examId") Long examId, @Param("groupType") String groupType,
            @Param("groupName") String groupName);

    List<String> absentQuerySummary(@Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    IPage<AbsentQueryVo> absentQueryPage(Page<AbsentQueryVo> page, @Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    List<AbsentQueryVo> absentExportList(Page<AbsentQueryVo> page, @Param("groupNameCol") String groupNameCol,
            @Param("query") AbsentQueryDomain query);

    IPage<AnswerQueryVo> queryPage(Page<AnswerQueryVo> page, @Param("query") AnswerQueryDomain query);

    List<String> querySummary(@Param("query") AnswerQueryDomain query);

    List<AnswerExportVo> exportList(Page<AnswerQueryVo> page, @Param("query") AnswerQueryDomain query);

    List<StudentUploadVo> findToUpload(@Param("pageSize") Integer pageSize, @Param("schoolId") Long schoolId);

    List<StudentUploadVo> findUploadError(@Param("pageSize") Integer pageSize, @Param("schoolId") Long schoolId);

    int getPackageCountByExam(@Param("examId") Long examId);

    int countByQuery(@Param("query") ImportStudentQueryVo query);

    IPage<ImportStudentVo> listPageQuery(Page<ImportStudentVo> page, @Param("query") ImportStudentQueryVo query);

    List<StudentUploadVo> findToPictureCopy(@Param("pageSize") Integer pageSize);

    int getUploadedCount(@Param("examId") Long examId);

    int getNeedUploadCount(@Param("examId") Long examId);

    IPage<ExportCetVo> listCetMarkingPage(Page<ExportCetVo> page, @Param("query") ExportCetMarkingQueryVo query);

    ScanAnswerInfoVo getInfoCountByExam(@Param("examId") Long examId);

    List<AssignedCheckExport> exportAssignedCheckPage(Page<AssignedCheckExport> page,
            @Param("query") AssignedQueryDomain query);

    IPage<AnswerQueryVo> queryAssignedCheckPage(Page<AnswerQueryVo> page, @Param("query") AssignedQueryDomain query);

    List<AnswerQueryVo> findUnCheck(@Param("examId") Long examId, @Param("pageNumber") int pageNumber,
            @Param("pageSize") int pageSize, @Param("checkCount") int checkCount);

    List<AnswerQueryVo> getAssignedCheckTaskHistory(@Param("id") Long id, @Param("pageSize") Long pageSize,
            @Param("userId") Long userId, @Param("examId") Long examId);

    void updateAssignedCheckCount(@Param("id") Long id);

    List<SubjectScanProgressVo> scanProgress(@Param("examId") Long examId, @Param("subjectCode") String subjectCode);

    IPage<ExamRoomScannedVo> examRoomScannedPage(Page<ExamRoomScannedVo> page,
            @Param("req") ExamRoomScannedQuery query);

    IPage<StudentPageVo> studentPage(Page<StudentPageVo> page, @Param("req") StudentPageQuery query);

    IPage<StudentVo> studentExport(Page<StudentVo> page, @Param("query") AnswerQueryDomain query);

    IPage<StudentExamRoomVo> studentExamRoomExport(Page<StudentExamRoomVo> page,
            @Param("query") AnswerQueryDomain query);

}
